/*
 * API iSendPro
 * [1] Liste des fonctionnalités : - envoi de SMS à un ou plusieurs destinataires, - lookup HLR, - récupération des récapitulatifs de campagne, - gestion des répertoires, - ajout en liste noire. - comptage du nombre de caractères des SMS  [2] Pour utiliser cette API vous devez: - Créer un compte iSendPro sur https://isendpro.com/ - Créditer votre compte      - Remarque: obtention d'un crédit de test possible sous conditions - Noter votre clé de compte (keyid)   - Elle vous sera indispensable à l'utilisation de l'API   - Vous pouvez la trouver dans le rubrique mon \"compte\", sous-rubrique \"mon API\" - Configurer le contrôle IP   - Le contrôle IP est configurable dans le rubrique mon \"compte\", sous-rubrique \"mon API\"   - Il s'agit d'un système de liste blanche, vous devez entrer les IP utilisées pour appeler l'API   - Vous pouvez également désactiver totalement le contrôle IP 
 *
 * OpenAPI spec version: 1.1.1
 * Contact: support@isendpro.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.api;

import io.swagger.client.ApiCallback;
import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import io.swagger.client.model.Erreur;
import io.swagger.client.model.REPERTOIREcreatereponse;
import io.swagger.client.model.REPERTOIREcreaterequest;
import io.swagger.client.model.REPERTOIREmodifreponse;
import io.swagger.client.model.REPERTOIREmodifrequest;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class RepertoireApi {
    private ApiClient apiClient;

    public RepertoireApi() {
        this(Configuration.getDefaultApiClient());
    }

    public RepertoireApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for repertoire
     * @param repertoiremodifrequest Requête de creation repertoire (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call repertoireCall(REPERTOIREmodifrequest repertoiremodifrequest, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = repertoiremodifrequest;

        // create path and map variables
        String localVarPath = "/repertoire";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "PUT", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call repertoireValidateBeforeCall(REPERTOIREmodifrequest repertoiremodifrequest, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'repertoiremodifrequest' is set
        if (repertoiremodifrequest == null) {
            throw new ApiException("Missing the required parameter 'repertoiremodifrequest' when calling repertoire(Async)");
        }
        

        com.squareup.okhttp.Call call = repertoireCall(repertoiremodifrequest, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Gestion repertoire (modification)
     * Ajoute ou supprime une liste de numéros à un répertoire existant.
     * @param repertoiremodifrequest Requête de creation repertoire (required)
     * @return REPERTOIREmodifreponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public REPERTOIREmodifreponse repertoire(REPERTOIREmodifrequest repertoiremodifrequest) throws ApiException {
        ApiResponse<REPERTOIREmodifreponse> resp = repertoireWithHttpInfo(repertoiremodifrequest);
        return resp.getData();
    }

    /**
     * Gestion repertoire (modification)
     * Ajoute ou supprime une liste de numéros à un répertoire existant.
     * @param repertoiremodifrequest Requête de creation repertoire (required)
     * @return ApiResponse&lt;REPERTOIREmodifreponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<REPERTOIREmodifreponse> repertoireWithHttpInfo(REPERTOIREmodifrequest repertoiremodifrequest) throws ApiException {
        com.squareup.okhttp.Call call = repertoireValidateBeforeCall(repertoiremodifrequest, null, null);
        Type localVarReturnType = new TypeToken<REPERTOIREmodifreponse>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Gestion repertoire (modification) (asynchronously)
     * Ajoute ou supprime une liste de numéros à un répertoire existant.
     * @param repertoiremodifrequest Requête de creation repertoire (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call repertoireAsync(REPERTOIREmodifrequest repertoiremodifrequest, final ApiCallback<REPERTOIREmodifreponse> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = repertoireValidateBeforeCall(repertoiremodifrequest, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<REPERTOIREmodifreponse>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for repertoireCrea
     * @param repertoirecreaterequest Creation repertoire (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call repertoireCreaCall(REPERTOIREcreaterequest repertoirecreaterequest, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = repertoirecreaterequest;

        // create path and map variables
        String localVarPath = "/repertoire";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call repertoireCreaValidateBeforeCall(REPERTOIREcreaterequest repertoirecreaterequest, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'repertoirecreaterequest' is set
        if (repertoirecreaterequest == null) {
            throw new ApiException("Missing the required parameter 'repertoirecreaterequest' when calling repertoireCrea(Async)");
        }
        

        com.squareup.okhttp.Call call = repertoireCreaCall(repertoirecreaterequest, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Gestion repertoire (creation)
     * Cree un nouveau répertoire et retourne son identifiant. Cet identifiant pourra être utilisé pour ajouter ou supprimer des numéros via l&#39;API.
     * @param repertoirecreaterequest Creation repertoire (required)
     * @return REPERTOIREcreatereponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public REPERTOIREcreatereponse repertoireCrea(REPERTOIREcreaterequest repertoirecreaterequest) throws ApiException {
        ApiResponse<REPERTOIREcreatereponse> resp = repertoireCreaWithHttpInfo(repertoirecreaterequest);
        return resp.getData();
    }

    /**
     * Gestion repertoire (creation)
     * Cree un nouveau répertoire et retourne son identifiant. Cet identifiant pourra être utilisé pour ajouter ou supprimer des numéros via l&#39;API.
     * @param repertoirecreaterequest Creation repertoire (required)
     * @return ApiResponse&lt;REPERTOIREcreatereponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<REPERTOIREcreatereponse> repertoireCreaWithHttpInfo(REPERTOIREcreaterequest repertoirecreaterequest) throws ApiException {
        com.squareup.okhttp.Call call = repertoireCreaValidateBeforeCall(repertoirecreaterequest, null, null);
        Type localVarReturnType = new TypeToken<REPERTOIREcreatereponse>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Gestion repertoire (creation) (asynchronously)
     * Cree un nouveau répertoire et retourne son identifiant. Cet identifiant pourra être utilisé pour ajouter ou supprimer des numéros via l&#39;API.
     * @param repertoirecreaterequest Creation repertoire (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call repertoireCreaAsync(REPERTOIREcreaterequest repertoirecreaterequest, final ApiCallback<REPERTOIREcreatereponse> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = repertoireCreaValidateBeforeCall(repertoirecreaterequest, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<REPERTOIREcreatereponse>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
