/*
 * API iSendPro
 * [1] Liste des fonctionnalités : - envoi de SMS à un ou plusieurs destinataires, - lookup HLR, - récupération des récapitulatifs de campagne, - gestion des répertoires, - ajout en liste noire. - comptage du nombre de caractères des SMS  [2] Pour utiliser cette API vous devez: - Créer un compte iSendPro sur https://isendpro.com/ - Créditer votre compte      - Remarque: obtention d'un crédit de test possible sous conditions - Noter votre clé de compte (keyid)   - Elle vous sera indispensable à l'utilisation de l'API   - Vous pouvez la trouver dans le rubrique mon \"compte\", sous-rubrique \"mon API\" - Configurer le contrôle IP   - Le contrôle IP est configurable dans le rubrique mon \"compte\", sous-rubrique \"mon API\"   - Il s'agit d'un système de liste blanche, vous devez entrer les IP utilisées pour appeler l'API   - Vous pouvez également désactiver totalement le contrôle IP 
 *
 * OpenAPI spec version: 1.1.1
 * Contact: support@isendpro.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.api;

import io.swagger.client.ApiCallback;
import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import io.swagger.client.model.Erreur;
import io.swagger.client.model.LISTENOIREReponse;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class SetListeNoireApi {
    private ApiClient apiClient;

    public SetListeNoireApi() {
        this(Configuration.getDefaultApiClient());
    }

    public SetListeNoireApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for setListeNoire
     * @param keyid Clé API (required)
     * @param setlisteNoire Doit valoir \&quot;1\&quot; (required)
     * @param num numéro de mobile à insérer en liste noire (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call setListeNoireCall(String keyid, String setlisteNoire, String num, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/setlistenoire";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (keyid != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("keyid", keyid));
        if (setlisteNoire != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("setlisteNoire", setlisteNoire));
        if (num != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("num", num));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call setListeNoireValidateBeforeCall(String keyid, String setlisteNoire, String num, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'keyid' is set
        if (keyid == null) {
            throw new ApiException("Missing the required parameter 'keyid' when calling setListeNoire(Async)");
        }
        
        // verify the required parameter 'setlisteNoire' is set
        if (setlisteNoire == null) {
            throw new ApiException("Missing the required parameter 'setlisteNoire' when calling setListeNoire(Async)");
        }
        
        // verify the required parameter 'num' is set
        if (num == null) {
            throw new ApiException("Missing the required parameter 'num' when calling setListeNoire(Async)");
        }
        

        com.squareup.okhttp.Call call = setListeNoireCall(keyid, setlisteNoire, num, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Ajoute un numero en liste noire
     * Ajoute un numero en liste noire. Une fois ajouté, les requêtes d&#39;envoi de SMS marketing vers ce numéro seront refusées.
     * @param keyid Clé API (required)
     * @param setlisteNoire Doit valoir \&quot;1\&quot; (required)
     * @param num numéro de mobile à insérer en liste noire (required)
     * @return LISTENOIREReponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public LISTENOIREReponse setListeNoire(String keyid, String setlisteNoire, String num) throws ApiException {
        ApiResponse<LISTENOIREReponse> resp = setListeNoireWithHttpInfo(keyid, setlisteNoire, num);
        return resp.getData();
    }

    /**
     * Ajoute un numero en liste noire
     * Ajoute un numero en liste noire. Une fois ajouté, les requêtes d&#39;envoi de SMS marketing vers ce numéro seront refusées.
     * @param keyid Clé API (required)
     * @param setlisteNoire Doit valoir \&quot;1\&quot; (required)
     * @param num numéro de mobile à insérer en liste noire (required)
     * @return ApiResponse&lt;LISTENOIREReponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<LISTENOIREReponse> setListeNoireWithHttpInfo(String keyid, String setlisteNoire, String num) throws ApiException {
        com.squareup.okhttp.Call call = setListeNoireValidateBeforeCall(keyid, setlisteNoire, num, null, null);
        Type localVarReturnType = new TypeToken<LISTENOIREReponse>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Ajoute un numero en liste noire (asynchronously)
     * Ajoute un numero en liste noire. Une fois ajouté, les requêtes d&#39;envoi de SMS marketing vers ce numéro seront refusées.
     * @param keyid Clé API (required)
     * @param setlisteNoire Doit valoir \&quot;1\&quot; (required)
     * @param num numéro de mobile à insérer en liste noire (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call setListeNoireAsync(String keyid, String setlisteNoire, String num, final ApiCallback<LISTENOIREReponse> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = setListeNoireValidateBeforeCall(keyid, setlisteNoire, num, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<LISTENOIREReponse>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
